#ifndef _capturethread__h_
#define _capturethread__h_

#include <windows.h>

class CaptureStream;
class DataBufferWriter;

/**
 * Manages the thread used for capturing audio data.
 */
class CaptureThread
{

public:

    // Constructor
    CaptureThread(CaptureStream &stream, DataBufferWriter &buffer);

    // Starts the capture thread.
    void start();
    // Stops the capture thread.
    void stop();

    // Returns whether or not the thread has finished.
    bool isFinished() const { return m_isFinished; }

private:

    // The thread procedure.
    static DWORD WINAPI threadProc(LPVOID param);

    // The AudioStream that we'll be writing to.
    CaptureStream &m_stream;
    // The data buffer. 
    DataBufferWriter &m_buffer;

    // The render thread handle
    HANDLE m_hThread;
    // Whether or not the thread should stop.
    bool m_stopThread;
    // Whether or not the thread has completed.
    bool m_isFinished;
};

#endif
