#ifndef _audioendpointenumerator__h_
#define _audioendpointenumerator__h_

#include "ComTypes.h"
#include <vector>

/**
 * Wraps IMMDeviceEnumerator, providing a simpler mechanism to enumerate
 * audio endpoints.
 */
class AudioEndpointEnumerator
{
public:

    // Constructor. May throw std::runtime_error.
    AudioEndpointEnumerator();

    // Enumerates all active devices. Returns the number of devices found. 
    // May throw std::runtime_error.
    size_t enumerateAudioDevices(std::vector<IMMDevicePtr> &foundDevices);

private:

    IMMDeviceEnumeratorPtr m_spDeviceEnumerator;
};

#endif
