#ifndef _deviceinfostreamwriter__h_
#define _deviceinfostreamwriter__h_

#include <Mmdeviceapi.h>
#include <ostream>

class DeviceInfoStreamWriter
{
public:

    // Writes device information to the specified output stream. 
    // May throw std::runtime_error.
    void writeDeviceInfo(IMMDevice &device, std::wostream &output);

private:

    void writeId(IMMDevice &device, std::wostream &output);
    void writeDataFlow(IMMDevice &device, std::wostream &output);
    void writeState(IMMDevice &device, std::wostream &output);
    void writeProperties(IMMDevice &device, std::wostream &output);

    void writeNameProperty(IPropertyStore &propertyStore, std::wostream &output);
    void writeFormFactoryProperty(IPropertyStore &propertyStore, std::wostream &output);
    void writePhysicalSpeakersProperty(IPropertyStore &propertyStore, 
		std::wostream &output);
    void writeCurrentAudioFormat(IPropertyStore &propertyStore, std::wostream &output);
    void writeOEMAudioFormat(IPropertyStore &propertyStore, std::wostream &output);

    void writeStringProperty(const PROPVARIANT &property, std::wostream &output);
    void writeWaveFormatProperty(const PROPVARIANT &property, std::wostream &output);
};

#endif
