﻿#include "DeviceInfoStreamWriter.h"
#include "AudioEndpointEnumerator.h"

#include <iostream>

int main(int argc, const char* argv[])
{
    // Initializing COM. This is required for all applications making use
    // of COM components.
    CoInitialize(nullptr);

    try
    {
        DeviceInfoStreamWriter writer;
        AudioEndpointEnumerator enumerator;
        std::cout << "Found Audio Endpoints: " << std::endl;

        std::vector<IMMDevicePtr> devices;
        if (enumerator.enumerateAudioDevices(devices) == 0)
            throw std::runtime_error("No audio endpoints found.");

        for (IMMDevicePtr &spDevice : devices)
            writer.writeDeviceInfo(spDevice, std::wcout);
    }
    catch (const std::runtime_error &e)
    {
        std::cerr << e.what() << std::endl;
    }

    // Uninitializing COM.
    CoUninitialize();

    return 0;
}
