#ifndef _audiodevices__h_
#define _audiodevices__h_

#include "ComTypes.h"

/**
 * Provides convenience functions for getting default audio devices.
 * All functions throw std::runtime_error on error.
 */
class AudioDevices
{

public:

    static IMMDevicePtr getDefaultRenderDevice();
    static IMMDevicePtr getDefaultCaptureDevice();

private:

    static IMMDeviceEnumeratorPtr getDeviceEnumerator();

    // Constructor. NOT IMPLEMENTED.
    AudioDevices() = delete;
};

#endif