#ifndef _renderthread__h_
#define _renderthread__h_

#include <windows.h>

class RenderStream;
class SineWaveGenerator;

/**
 * Manages the thread used for rendering audio data.
 */
class RenderThread
{

public:

    // Constructor
    RenderThread(RenderStream &stream, SineWaveGenerator &sampleSource);

    // Starts the render thread.
    void start();
    // Stops the render thread.
    void stop();

private:

    // The thread procedure.
    static DWORD WINAPI threadProc(LPVOID param);

    // The AudioStream that we'll be writing to.
    RenderStream &m_stream;
    // The audio data source. 
    SineWaveGenerator &m_sampleSource;

    // The render thread handle
    HANDLE m_hThread;
    // Whether or not the thread should stop.
    bool m_stopThread;
};

#endif
