#ifndef _keymonitor__h_
#define _keymonitor__h_

#include <Windows.h>

/**
 * Used to monitor the console for key presses.
 */
class KeyMonitor
{

public:

    // Constructor.
    KeyMonitor();

    // The key presses we're interested in.
    enum class KeyPress
    {
        Up,
        Down,
        Left,
        Right,
        Q,
        None
    };

    KeyPress getKeyPress(bool waitForKeyPress = true) const;

private:

    // Handle to the console's stdout. Unlike most HANDLES,
    // m_hConsole doesn't need to be explicitly closed.
    HANDLE m_hConsole; 
};

#endif